require "import"
import "android.speech.RecognizerIntent"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.content.Intent"

if not service.getEditText() then
service.asyncSpeak("Sorry! Text Box Not Found!")
return false
end

local autoPunctuationByHemantSingal = ". "

local recordIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
recordIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
recordIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "en-US")

local wordChangeTable = {

[""] = "", 
[""] = "", 
[""] = "", 
[""] = "", 
[""] = "", 
[""] = "", 
[""] = "", 


--Dont change the  below entries.

["george"] = "JAWS",
["jose"] = "JAWS",
["josh"] = "JAWS",
["nvidia"] = "NVDA",
["nvda"] = "NVDA",
["jiso"] = "Jieshuo",
["jisho"] = "Jieshuo",
["jishu"] = "Jieshuo",
["jisu"] = "Jieshuo",
["g sho"] = "Jieshuo",
["ji show"] = "Jieshuo",
["loha"] = "Lua",
["lower language"] = "Lua Language",
["luva"] = "Lua",
["luha"] = "Lua",
[" loa "] = "Lua",
["english tts"] = "ETI Eloquence",
["thumbs up"] = "馃憤",
["red heart"] = "鉂�",
["red hot"] = "鉂�",
["okay hand"] = "馃憣",
["ok hand"] = "馃憣",
["folded hands"] = "馃檹",
["folded hand"] = "馃檹",
["bullet"] = "鈥�  ",
[""] = "",
["new line"] = "\n",
["new paragraph"] = "\n\n",
["question symbol"] = "?",
["questions symbol"] = "?",
["question simple"] = "?",
["fullstop"] = ".",
["full stop"] = ".",
["fold stop"] = ".",
["food stop"] = ".",
["comma"] = ",",
["coma"] = ",",
[" kama "] = ",",
[" cama "] = ",",
["colon"] = ":",
["colen "] = ":",
["colan "] = ":",
["kolan "] = ":",
["bang symbol"] = "!",
["bank symbol"] = "!",
["at symbol"] = "@",
["ate symbol"] = "@",
["ad symbol"] = "@",
["add symbol"] = "@",
["hash symbol"] = "#",
["has symbol"] = "#",
["ha symbol"] = "#",
["star symbol"] = "*",
["dollar symbol"] = "$",
["doller symbol"] = "$",
["dolla symbol"] = "$",
["dollor symbol"] = "$",
["black slash"] = "\\",
["backslash"] = "\\",
["backflash"] = "\\",
["back flash"] = "\\",
["backless"] = "\\",
["backlash"] = "\\",
["more than symbol"] = ">",
["mordhan symbol"] = ">",
["less than symbol"] = "<",
["space bar"] = " ",
["plus symbol"] = "+",
["left round"] = "(",
["right round"] = ")",
["left square"] = "[",
["right square"] = "]",
["left curly"] = "{",
["left kar li"] = "{",
["right curly"] = "}",
["right kar li"] = "}",
["quote"] = "\"",
["coat"] = "\"",
["court"] = "\"",
["and symbol"] = "&",
["percent symbol"] = "%%",
["person symbol"] = "%%",
["present symbol"] = "%%",
["equal symbol"] = "=",
["vertical bar"] = "|",

[""] = "", 
[""] = ""
}

local speechRecord = SpeechRecognizer.createSpeechRecognizer(service)
speechRecord.setRecognitionListener{
onResults = function(results)
local spokenText = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION).get(0)
for k, v in pairs(wordChangeTable) do 
spokenText = spokenText:gsub(k:gsub("%a", function(c) return string.format("[%s%s]", c:lower(), c:upper()) end), v) 
end

spokenText = spokenText:gsub("(%s)([(){}%[%]@#%$%%&*\\|\"<>!:,.?])", "%2")

spokenText = spokenText:gsub("([(){}%[%]@#%$%%&*\\|\"<>])%s", "%1")

spokenText = spokenText:gsub("^%l", string.upper)

spokenText = spokenText:gsub("([!?.:;]%s*)(%l)", function(punct, letter)
return punct .. string.upper(letter)
end)

service.insertText(service.getEditText(), spokenText .. autoPunctuationByHemantSingal)
service.speak(spokenText)
speechRecord.destroy()
end,
onError = function()
speechRecord.destroy()
service.asyncSpeak("Sorry! I Did Not Understand Your Message!")
end
}
speechRecord.startListening(recordIntent)